<template>
  <v-hover>
    <template #default="{ isHovering, props }">
      <div
        v-bind="props"
        class="flex items-center gap-1 w-full"
        :class="[sortableClass()]"
        @click="update"
      >
        <!-- Prepend Icon -->
        <div v-if="prependIcon">
          <Icon
            :icon="prependIcon"
            class="w-4 h-4 text-dark-grey"
          />
        </div>
    
        <!-- Header text -->
        <p class="font-medium text-xs text-dark-grey text-nowrap">
          {{ text }}
        </p>
    
        <!-- Append Icon -->
        <div v-if="info">
          <Icon
            icon="ic:baseline-help-outline"
            class="w-4 h-4 text-middle-grey"
          />
        </div>

        <!-- Sortable Hover Icon -->
        <div v-if="sortable">
          <Icon
            v-if="isHovering"
            :icon="modelValue === '' ? 'ic:outline-arrow-upward' : sortableIcon()"
            class="w-4 h-4 text-dark-grey"
          />

          <Icon
            v-else
            :icon="sortableIcon()"
            class="w-4 h-4 text-dark-grey"
          />
        </div>
      </div>
    </template>
  </v-hover>
</template>

<script setup>
import { ref } from "vue";
import { Icon } from "@iconify/vue";

const props = defineProps({
  prependIcon: {
    type: String,
    default: ''
  },
  sortable: {
    type: Boolean,
    default: false
  },
  info: {
    type: Boolean,
    default: false
  },
  text: {
    type: String,
    default: 'text'
  }
})

const emits = defineEmits(['update:modelValue']);

const modelValue = ref('')

const update = () => {
  if (props.sortable) {
    switch (modelValue.value) {
      case '':
        modelValue.value = 'asc'
        break;
      case 'asc':
        modelValue.value = 'desc'
        break;
      case 'desc':
        modelValue.value = ''
        break;
    }
    emits('update:modelValue', modelValue.value)
  }
}

const sortableIcon = () => {
  switch (modelValue.value) {
    case '':
      return ''
    case 'asc':
      return 'ic:outline-arrow-upward'
    case 'desc':
      return 'ic:outline-arrow-downward'
  }
}

const sortableClass = () => {
  if (props.sortable) {
    return "cursor-pointer hover:bg-very-light-grey active:bg-light-grey"
  } else {
    return "cursor-default"
  }
}
</script>

<style scoped>

</style>